package rmiClient;

import java.io.IOException;

import javax.smartcardio.ATR;
import javax.smartcardio.Card;
import javax.smartcardio.CardChannel;
import javax.smartcardio.CardTerminal;
import javax.smartcardio.CardTerminals;
import javax.smartcardio.CommandAPDU;
import javax.smartcardio.ResponseAPDU;
import javax.smartcardio.TerminalFactory;
import jsr268gp.util.Util;

import com.sun.javacard.clientlib.CardAccessor;

/*
 * commenter !! :D
 */

public class PCSCAccessor implements CardAccessor {
	Card c;
	CardChannel cc;	
	CommandAPDU capdu;
	ResponseAPDU rapdu;
	
	public PCSCAccessor(){
		
		TerminalFactory tf = TerminalFactory.getDefault();
		CardTerminals list = tf.terminals();
		CardTerminal cad = list.getTerminal("Gemplus USB Smart Card Reader 0");
		
		try {
			
			c = cad.connect("T=0");
			System.out.println("Card: "+c);
			ATR atr = c.getATR();
			System.out.println("ATR: "+Util.byteArrayToHexString(atr.getBytes(), " ")+"\n");
			cc = c.getBasicChannel();
		}
		catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}finally{
		} 
	}

	public void closeCard() throws Exception {
		try{
			c.disconnect(true);
		}catch(javax.smartcardio.CardException c){
			System.out.println(c.getMessage());
		}catch(Exception e){
			e.printStackTrace();
		}
	}

	public byte[] exchangeAPDU(byte[] arg0) throws IOException {
		try{
			byte[] rapdu = cc.transmit(new CommandAPDU(arg0)).getBytes();

			/*
			 * l'APDU recue contien le SW  la fin du byte[]
			 * la classe qui accede au Card Accessor attend le SW au dbut du byte[]
			 * le code suivant fait ce dplacement.
			 */
			
			//extraction de SW a la fin de rapdu
			byte[] sw = new byte[2];
			sw[0] = rapdu [rapdu.length-2];
			sw[1] = rapdu [rapdu.length-1];
			
			//mise du SW en tete de retour et copie du reste de rapdu.
			byte []retour = new byte [rapdu.length]; 
			retour[0]= sw[0];
			retour[1]= sw[1];
			for (int i = 0; i<rapdu.length-2; i++){
				retour[i+2] = rapdu[i];
			}
			return retour;
		}catch(javax.smartcardio.CardException ce){
			System.out.println(ce.getMessage());
			return null;
		}
	}
					
	
	public String toString(){
		return "card accessor PCSC gp [made in CEDRIC]";
	}

}
