package rmiServeur;

import java.rmi.*;

import rmiServeur.WalletInterface;
import javacard.framework.*;
import javacard.framework.service.*;

public class Wallet extends CardRemoteObject implements WalletInterface {
  //protected SecurityService security;
  protected OwnerPIN pin;
  private short solde;
  
  public Wallet() {
    super();
    solde = (short)0;
    pin = new OwnerPIN((byte)3, (byte)4); //(byte tryLimit, byte maxPINSize) 
    pin.update(new byte[]{(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00}, (short)0, (byte)4);
  }

 /* public Wallet(SecurityService security) {
    this();
    //With security member variable, the remote object is able to check 
    //the current state of the channel.
    //The usage of this variable is optional and depends on your applet implementation.
    this.security = security;
  }*/
 
  public boolean login(byte[] tryPin) throws RemoteException, UserException {    
    return pin.check(tryPin, (short)0, (byte)tryPin.length);
  }

  public void crediter(short credit) throws RemoteException, UserException {
	  if(!pin.isValidated())
		  UserException.throwIt(ERR_ACCESS);
	  if (credit<0) 
		  UserException.throwIt(ERR_CREDIT);
	  if ((short)(solde+credit)<0)
		  UserException.throwIt(ERR_OVERFLOW);
	  
	  //crdite si les conditions sont bonnes.  
	  solde += credit;
  }

  public void debiter(short debit) throws RemoteException, UserException {
	  if(!pin.isValidated())
		  UserException.throwIt(ERR_ACCESS);
	  if(debit<0)
		  UserException.throwIt(ERR_DEBIT);
	  if (solde<debit)
		  UserException.throwIt(ERR_SOLDE);
	  if((short)(solde-debit)<0)
		  UserException.throwIt(ERR_UNDERFLOW);
	  
	  //dbite si les conditions sont bonnes.  
	  solde -= debit;
  }

  public void delog() throws RemoteException, UserException {
	pin.reset();
  }
  
  public void setPIN(byte[] newPin) throws RemoteException, UserException {
	  if(!pin.isValidated())
		  UserException.throwIt(ERR_ACCESS);
	  
	  //modifie le pin si l'acces est permis
	  pin.update(newPin, (short)0, (byte)newPin.length);	
  }
  
  public short getSolde() throws RemoteException, UserException {
	  if(!pin.isValidated())
		  UserException.throwIt(ERR_ACCESS);
	  return solde;
  }
}